<?php

namespace Drupal\bigint\Plugin\Field\FieldFormatter;

use Drupal\Core\Field\Plugin\Field\FieldFormatter\IntegerFormatter;

/**
 * Plugin implementation of the 'Default' formatter for 'bigint' fields.
 *
 * @FieldFormatter(
 *   id = "bigint_item_default",
 *   label = @Translation("Default"),
 *   field_types = {
 *     "bigint"
 *   }
 * )
 */
class BigIntItemDefaultFormatter extends IntegerFormatter {

  /**
   * {@inheritdoc}
   */
  protected function numberFormat($number) {
    $number = (string) $number;
    $thousands = [];
    while (strlen($number) > 0) {
      array_unshift($thousands, substr($number, -3));
      $number = substr($number, 0, strlen($number) - 3);
    }
    return implode($this->getSetting('thousand_separator'), $thousands);
  }

}
